精华内容
下载资源
问答
  • throw关键字

    2020-06-19 19:28:00
    throw关键字 作用: 可以使用throw关键字在指定的方法中抛出指定的异常 使用格式: throw new xxxException(“异常产生的原因”) 注意: 1、throw关键字必须写在方法的内部 2、throw关键字后边new的对象...

    throw关键字

      作用:
       可以使用throw关键字在指定的方法中抛出指定的异常
      使用格式:
       throw new xxxException(“异常产生的原因”)
     注意:
       1throw关键字必须写在方法的内部
       2throw关键字后边new的对象必须是Exception或者Exception的子类对象
       3throw关键字抛出指定的异常对象,我们就必须处理这个异常对象
        	throw关键字后边创建的是RumtimeException或者是RumtimeException的子类对象,我们可以不处理,默认交给JVM处理(打印异常对象,中断程序)
       	throw关键字后边创建的是编译异常(写代码的时候报错),我们就必须处理这个异常,要么throw,要么try...catch
    /*
      定义一个方法,获取数组指定索引处的元素
      参数:
       int[] arr
       int index
      以后(在工作中)我们首先必须对方法传递过来的参数进行合法性校验
      如果参数不合法,那么我们就必须使用抛出异常的方式,告知方法的调用者,传递的参数有问题。
      注意:
       NullPointerException是一个运行期异常,我们不用处理,默认交给JVM处理
       ArrayIndexOutOfBoundsException是一个运行期异常,我们不用处理,默认交给JVM处理
     */
    public static int getElement(int[] arr, int index) {
     	/*
    	   我们可以对传递过来的参数数组,进行合法性校验
    	   如果数组arr的值是null
    	   那么我们就抛出空指针异常,告知方法的调用者“传递的数组的值是null”
    	  */
    	 if(arr == null) {
     		 throw new NullPointerException("传递的数组的值是空!");
    	 }
    	 /*
    	   我们可以对传递过来的参数index进行合法性校验
    	   如果index的范围不在数组的索引范围内
    	   那么我们就抛出数组索引越界异常,告知方法的调用者“传递的索引超出了数组的适用范围”
    	  */
    	if(index < 0 || index > arr.length-1) {
    		throw new ArrayIndexOutOfBoundsException("传递的索引超出了数组的使用范围");
    	}
    	int ele = arr[index];
    	return ele;
    }
    展开全文
  • Java异常throw关键字

    2021-06-04 00:02:35
    throw关键字 作用: 可以使用throw关键字在指定的方法中抛出指定的异常 使用格式: throw new xxxException("异常产生的原因"); 注意: 1.throw关键字必须写在方法的内部 2.throw关键字后边new的对象必须是...
     package ExceptionDemo;
    /*
        throw关键字
        作用:
            可以使用throw关键字在指定的方法中抛出指定的异常
        使用格式:
            throw new xxxException("异常产生的原因");
        注意:
            1.throw关键字必须写在方法的内部
            2.throw关键字后边new的对象必须是Exception或者Exception的子类对象
            3.throw关键字抛出指定的异常对象,我们就必须处理这个异常对象
                throw关键字后边创建的是RuntimeException或者是 RuntimeException的子类对象,我们可以不处理,默认交给JVM处理(打印异常对象,中断程序)
                throw关键字后边创建的是编译异常(写代码的时候报错),我们就必须处理这个异常,要么throws,要么try...catch
     */
    public class Demo03Throw {
        public static void main(String[] args) {
            //int[] arr = null;
            int[] arr = new int[3];
            int e = getElement(arr,3);
            System.out.println(e);
        }
        /*
            定义一个方法,获取数组指定索引处的元素
            参数:
                int[] arr
                int index
            以后(工作中)我们首先必须对方法传递过来的参数进行合法性校验
            如果参数不合法,那么我们就必须使用抛出异常的方式,告知方法的调用者,传递的参数有问题
            注意:
                NullPointerException是一个运行期异常,我们不用处理,默认交给JVM处理
                ArrayIndexOutOfBoundsException是一个运行期异常,我们不用处理,默认交给JVM处理
         */
        public static int getElement(int[] arr,int index){
            /*
                我们可以对传递过来的参数数组,进行合法性校验
                如果数组arr的值是null
                那么我们就抛出空指针异常,告知方法的调用者"传递的数组的值是null"
             */
            if(arr == null){
                throw new NullPointerException("传递的数组的值是null");
            }
    
            /*
                我们可以对传递过来的参数index进行合法性校验
                如果index的范围不在数组的索引范围内
                那么我们就抛出数组索引越界异常,告知方法的调用者"传递的索引超出了数组的使用范围"
             */
            if(index<0 || index>arr.length-1){
                throw new ArrayIndexOutOfBoundsException("传递的索引超出了数组的使用范围");
            }
    
            int ele = arr[index];
            return ele;
        }
    }
    
    
    展开全文
  • Java 基础 throw关键字

    2020-03-22 15:02:18
    * 可以使用throw关键字在指定的方法中抛出指定的异常 * 使用格式: * throw new XXXException("异常产生的原因"); * 注意: * 1.throw关键字必须写在方法的内部 * 2.throw关键字后面new的对象必须是Exception或者...
    package demo1;
    
    
    /*
    * throw 关键字
    * 作用:
    *   可以使用throw关键字在指定的方法中抛出指定的异常
    * 使用格式:
    *   throw new XXXException("异常产生的原因");
    * 注意:
    *   1.throw关键字必须写在方法的内部
    *   2.throw关键字后面new的对象必须是Exception或者Exception的子类对象
    *   3.throw关键字抛出指定的异常对象,我们就必须处理这个异常现象
    *       throw关键字后边创建的是RuntimeException或者是RuntimeException的子类对象,我们可以不处理,默认交给JVM处理(打印异常对象,中断
    * 程序)
    *       throw关键字后边创建的是编译异常(写代码的时候报错),我们就必须处理这个异常,要么throws,要么try。。。。catch*/
    public class DemoException {
        public static void main(String[] args) {
            /*
            * 定义一个方法,获取数组指定索引处的元素
            * 参数:
            *   int[] arr
            *   int index
            * 以后我们首先必须对方法传递过来的参数进行合法性校验
            * 如果参数不合法,那么我们就必须使用抛出异常的方式,告知方法的调用者,传递的参数有问题*/
            int[] arr = {1,3,5};
            int[] arr1 = {};
    //        int result_arr = getElement(arr,0);
    //        System.out.println(result_arr);
            getElement(arr1,0);
    
    
    //        getElement(arr,0);
    
    
    
        }
        public static int getElement(int[] arr, int index)  {
            if(arr==null){
                throw new NullPointerException("指针为空");
            }else if(index>=arr.length-1){
                throw new ArrayIndexOutOfBoundsException("数组越界");
            }
            int ele = arr[index];
            return ele;
    
        }
    }
    
    展开全文
  • 11.Java–throw关键字

    2020-08-30 15:13:06
    11.Java–throw关键字 除了可以通过throws关键字抛出异常外,还可以使用throw关键字抛出异常。与throws有所不同的是,throw用于方法体内,并且抛出的是一个异常类对象,而throws关键字用在方法声明中,用来指明方法可能抛...

    11.Java–throw关键字

    除了可以通过throws关键字抛出异常外,还可以使用throw关键字抛出异常。与throws有所不同的是,throw用于方法体内,并且抛出的是一个异常类对象,而throws关键字用在方法声明中,用来指明方法可能抛出的多个异常

    通过throw关键字抛出异常后,还需要使用throws关键字或try…catch对异常进行处理

    需要注意的是,如果throw抛出的是Error、RuntimeException或它们的子类异常现象无需使用throws关键字或try…catch对异常进行处理。

    案例

    public class Example34 {
    	// 定义printAge()输出年龄
    	public static void printAge(int age) throws Exception {
    		if (age < 0) {
    			// 对业务逻辑进行判断,当输入年龄为负数的时候抛出异常
    			throw new Exception("输入的年龄有误,必须是正整数!");
    		} else {
    			System.out.println("此人年龄为:" + age);
    		}
    	}
    
    	public static void main(String[] args) {
    		// 下面的代码定义了一个try...catch语句用于捕获异常
    		int age = -1;
    		try {
    			printAge(age);
    		} catch (Exception e) {
    			System.out.println("捕获的异常信息为:" + e.getMessage());
    		}
    	}
    }
    

    结果

    在这里插入图片描述

    例34中, printAge()方法对输人的年龄进行了逻辑判断,虽然输入负数在语法上能够通过编译,并且程序能够正常运行,但这显然与现实情况不符,因此需要在方法中对输入的内容进行判断,当数值小于0时,使用throw关键字抛出异常,并指定异常提示信息,同时,在方法后继续用throws关键字处理抛出的异常。

    从图可以看出,对于代码中的业务逻辑异常,使用throw关键字抛出异常后,同样可以正确捕获异常,从而保证程序的正常运行。当然,throw关键字除了可以抛出代码的逻辑性异常外,也可以抛出Java能够自动识别的异常

    展开全文
  • throws关键字和throw关键字的区别主要在于: 1.throws关键字在方法的声明上使用,表示此方法在调用的时候必须处理异常 2.throw关键字指的是在方法中,人为的抛出一个异常(这个异常对象可能是自己实例化,或者是抛出...
  • 11.6throw关键字

    2020-03-08 16:11:51
    在默认情况下,所有的异常类的实例化对象都会由JVM默认实例化并且自动抛出,用了方便用户手动进行异常的抛出,JVM提供了有一个throw关键字。 范例:手动异常抛出 public class JavaDemo { public static void main...
  • throws 与 throw 关键字

    2019-09-28 16:45:17
    二 、throw 关键字 三 、实例 ----throws 与 throw 的应用 一 、throws 关键字 在定义一个方法时可以使用 throws 关键字声明,使用 throws 声明的方法表示此方法不处理异常,而是交给方法的调用处进行处理 ...
  • C#的异常处理之Throw关键字
  • Java--throw关键字

    2017-09-24 22:13:03
    throw关键字 1.throw关键字抛出一个异常,抛出的时候直接抛出异常类的实例化对象即可。 2.例子: try { throw new Exception("实例化异常对象"); } catch (Exception e){ System.out.println(e); }
  • throw关键字 作用: 可以使用throw关键字在指定的方法中抛出指定的异常 使用格式: throw new xxxException(“原因”); 注意: 1.必须写在方法的内部 2.后面new的对象必须是Exception或者是其子类 3.抛出指定的异常...
  • 主要介绍了Java编程中使用throw关键字抛出异常的用法,是Java入门学习中的基础知识,需要的朋友可以参考下
  • 异常 java中throw关键字

    2020-01-11 16:08:44
    throw关键字 public class Demo03Throw { public static void main(String[] args) { // int[] arr = null;//Exception in thread "main" java.lang.NullPointerException: 传递的数组为null int[] arr =...
  • throws与throw关键字详解

    千次阅读 2019-01-19 16:50:59
    throws与throw关键字详解 throws关键字 throws关键字用在方法声明上,明确告诉调用者本方法可能产生的的异常,但方法本身不处理,用throws向上层抛出。 //throws关键字的简单使用 public class Test{ public static...
  • throw关键字(注意区分throws关键字)

    千次阅读 2018-05-05 20:01:09
    throw关键字(注意区分throws关键字)throw是直接编写在语句之中的,表示人为进行异常的抛出。例如,在之前使用过了一个10/0这样的语句,而这样的语句执行之后所产生的数学异常是由JVM负责进行异常类的对象实例化了...
  • 抛出throw关键字2---马克-to-win java 视频的详细描述
  • 抛出throw关键字1---马克-to-win java视频的详细描述与介绍
  • Java异常 异常指的是程序执行过程中,导致AVM虚拟机停止工作。 如果程序运行出现异常,JVM...作用:可以使用throw关键字在指定的方法中抛出异常。 JVM终止正在执行的程序。 /** * * @author jianyeli */ public cl

空空如也

空空如也

1 2 3 4 5 ... 20
收藏数 3,260
精华内容 1,304
关键字:

throw关键字